<template>
  <el-dialog width="1400px" :model-value="modelValue" append-to-body @close="closed">
    <template #title>
        <span class="mr10 f16">选择布控群体</span>
    </template>
    <el-form :model="listQuery" :inline="true">
      <el-form-item label="群体名称">
          <el-input placeholder="请输入群体名称" v-model="listQuery.qtMc" clearable ></el-input>
      </el-form-item>
      <el-form-item>
          <el-button type="success" @click="handleFilter">查询</el-button>
          <el-button type="info" @click="reset()"> 重置 </el-button>
      </el-form-item>
    </el-form>
    <div class="tabBox" :class="props.Single ? 'tabBoxRadio' : ''" style="margin-top: 0px">
    <el-table ref="multipleUserRef" v-loading="loading" :key="keyTabel" @selection-change="handleSelectionChange" :data="tableData" border :row-key="keyid" style="width: 100%" height="450">
        <el-table-column type="selection" width="55" :reserve-selection="true"/>
        <el-table-column type="expand">
          <template #default="props">
            <div class="pl20 pr10 pt10 pb10">
              <el-table :data="props.row.zdryList" >
                <el-table-column label="姓名" prop="ryXm" align="center" />
                <el-table-column prop="rySfzh" align="center" label="身份证"/>
                <el-table-column prop="ryXb" align="center" label="性别">
                    <template #default="{ row }">
                      <DictTag :tag="false"  :value="row.ryXb" :options="D_BZ_XB" />
                    </template>
                </el-table-column>
                <el-table-column prop="ryMz" align="center" label="民族">
                    <template #default="{ row }">
                      <DictTag :value="row.ryMz" :tag="false" :options="D_BZ_MZ" />
                    </template>
                </el-table-column>
                <el-table-column prop="ryLxdh" align="center" label="手机号"/>
                <el-table-column prop="xzdXz" align="center" label="现居住址"/>
                <el-table-column prop="bqList" align="center" label="人员标签">
                  <template #default="{ row }">
                      <span v-if="row.bqList">
                        <span v-for="(it,idx) in row.bqList" :key="idx"> {{ it.bqMc }}、</span>
                      </span>
                    </template>
                </el-table-column>
              </el-table>
            </div>
          </template>
        </el-table-column>
        <el-table-column prop="qtMc" align="center" label="群体名称"/>
        <el-table-column prop="qtFxdj" align="center" label="风险等级">
            <template #default="{ row }">
                <DictTag :value="row.qtFxdj" :tag="false" :options="D_GS_ZDQT_FXDJ" />
            </template>
        </el-table-column>
    </el-table>
    </div>
    <div class="fenye flex just-end " :style="{ top: tableHeight + 'px' }">
    <el-pagination
      class="pagination"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="listQuery.pageCurrent"
      :page-sizes="[10, 20, 50, 100]"
      :page-size="listQuery.pageSize"
      layout="total, sizes, prev, pager, next, jumper"
      :total="total"
    ></el-pagination>
    </div>
    <template #footer>
      <div class="flex just-center">
        <el-button type="primary" @click="onComfirm">确认</el-button>
        <el-button @click="closed">取消</el-button>
      </div>
    </template>
  </el-dialog>

</template>

<script setup>
import { qcckGet} from "@/api/qcckApi.js";
import { defineProps, ref ,getCurrentInstance, watch} from "vue";
const { proxy } = getCurrentInstance();
const { D_BZ_XB,D_GS_ZDQT_FXDJ,D_BZ_MZ } = proxy.$dict("D_BZ_XB","D_GS_ZDQT_FXDJ","D_BZ_MZ"); //获取字典数据
const props = defineProps({
  modelValue: {
    type: Boolean,
    default:false
  },
  LeaderType: {
    type: String,
    default: ""
  },
  //是否单选
  Single: {
    type: Boolean,
    default: false
  },
  roleIds: {
    type: Array,
    default: []
  },
});
const loading = ref(false)
const total = ref(0);
const listQuery = ref({
  pageCurrent: 1,
  pageSize: 20
});
const multipleUserRef = ref(null);
const multipleSelectionUser = ref([]);
const tableData = ref([]);
const emits = defineEmits(["update:modelValue", "choosed"]);
const keyTabel = ref(0)
const keyid = (row) => {
  return row.id;
};

const closed = () => {
  emits("update:modelValue", false);
};
const reset = () => {
  listQuery.value = {  pageCurrent: 1, pageSize: 20, };
  getListData();
};


// 为用户分配角色
const onComfirm = () => {
  const userList = multipleSelectionUser.value;
  let list = [];
  let listId = [];
  userList.forEach((val) => {
    if (listId.indexOf(val.id) == -1) {
      list.push(val);
      listId.push(val.id);
    }
  });
  emits("choosed", list);
  closed();
};

/**
 * pageSize 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.pageSize = currentSize;
  getListData();
};
/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.pageCurrent = currentPage;
  getListData();
};
const getListData = () => {
  keyTabel.value++
  loading.value = true;
  const params = {...listQuery.value}
  qcckGet(params,'/mosty-gsxt/tbGsxtZdqt/selectPage').then(res=>{
    loading.value = false;
    tableData.value = res.records || [];
    total.value = res.total;
    multipleUser();
  }).catch(()=>{
    loading.value = false;
  })
};

//列表回显
function multipleUser() {
  tableData.value.forEach((item) => {
     multipleUserRef.value.toggleRowSelection(item, false);
    if (props.roleIds.some((id) => id == item.id)) {
      multipleUserRef.value.toggleRowSelection(item, true);
    }
  });
}

const handleFilter = () => {
  listQuery.value.pageCurrent = 1;
  getListData();
};

const handleSelectionChange = (val) => {
  if (props.Single) {
    if (val.length > 1) {
      let del_row = val.shift();
      multipleUserRef.value.toggleRowSelection(del_row, false);
    }
    multipleSelectionUser.value = val;
  } else {
    multipleSelectionUser.value = val;
  }
};

watch(()=>props.modelValue,val=>{
  if(val) handleFilter();
},{immediate:true})

</script>

<style lang="scss" scoped>
@import "@/assets/css/layout.scss";
@import "@/assets/css/element-plus.scss";
</style>
<style>
.tabBoxRadio .el-checkbox__inner {
  border-radius: 50% !important;
}
.tabBoxRadio .el-table__header-wrapper .el-checkbox {
  display: none;
}

</style>
